100 '            relocate.bas
110 '
111 '   the basic program that batches locating previously picked events.
112 '   it is to be used if you want to change your velocity model or
113 '   station location in HYPO71.
115 '   it does:
117 '       a) gets a list of all the current *.pha files in the local
119 '          directory.
121 '       b) builds the batch file to move all the phase files through
123 '          hypo71 (they go through individually).  
125 '       c) executes the batch file.
500 '------------------------------------------------------------------------
501 '   we need to know where hypo71pc is located
512 HYPO$="C:\QUAKES\HYPO71"
514 '   and the name of the hypo input file
516 MODEL$="STATIONA.INP"
520 '
521 '     get a listing of all *.pha files 
525 SHELL "DIR *.PHA /A:-D /B > ERASEME.DAT"
530 '     now read through the file, counting the number of events
531 OPEN "ERASEME.DAT" FOR INPUT AS 1
532 NUM%=0 
535 IF EOF (1) THEN CLOSE (1) : GOTO 550
537    LINE INPUT #1, ALINE$ 
539    NUM%=NUM%+1
540    GOTO 535
550 PRINT USING "##### EVENTS TO BE RE-LOCATED"; NUM%
551 IF NUM%=0 THEN SYSTEM
552 LINE INPUT "CONTINUE (C) OR STOP (S) "; HUH$
554 IF (HUH$="C") OR (HUH$="c") THEN GOTO 560
555 IF (HUH$="S") OR (HUH$="s") THEN SYSTEM 
560 '      we need to know the path to the local directory
562 SHELL "DIR XXXXXX.XXX > ERASEME2.DAT"
564 OPEN "ERASEME2.DAT" FOR INPUT AS #1
566 LINE INPUT #1, ALINE$
568    SPOT%=INSTR(ALINE$,"Directory of")
570    IF SPOT%=0 THEN GOTO 566
572 '       grab the local directory
574 LOCAL$=MID$(ALINE$,15,(LEN(ALINE$)-14))+"\"
576 CLOSE (1) : SHELL "ERASE ERASEME2.DAT"
600 '-----------------------------------------------------------------------
605 '        build the batch file
610 OPEN "ERASEME.DAT" FOR INPUT AS 1
620 OPEN "HYPO_EM.BAT" FOR OUTPUT AS 2
621 PRINT #2, "DEL ERASEME.DAT"
660 IF EOF(1) THEN CLOSE (1) : GOTO 2000
675    LINE INPUT #1, PhaFile$
680    L%=LEN(PhaFile$)
682    EVNT$=MID$(PhaFile$,L%-11,8)
686    PhaIn$=HYPO$+"\"+EVNT$+".INP"
732 '       create the hypo phase/station input file
735    PRINT #2, "COPY "+HYPO$+"\"+MODEL$+" + "+LOCAL$+PhaFile$+" "+PhaIn$
748 '        hypo needs to be run in the hypo directory
749    PRINT #2, "CD "+HYPO$
750 '        create the answers for the hypo prompts
751    PRINT #2, "HYPOIN.EXE "+EVNT$
752 '        run hypo
755    PRINT #2, HYPO$+"\HYPO71PC.EXE < HYPOIN.TXT"
756    PRINT #2, " "
757 '        get rid of the input file
759 '  PRINT #2, "DEL "+EVNT$+".INP"
760 '        take the first line out of the PUN file
765    PRINT #2, HYPO$+"\NO_HDR.EXE "+HYPO$+"\"+EVNT$+".PUN"
823    PRINT #2, "     XCOPY "+HYPO$+"\"+EVNT$+".* "+LOCAL$+"*.*"
824    PRINT #2, "     ERASE "+HYPO$+"\"+EVNT$+".* "
900    GOTO 660
1999 '---------------------------------------------------
2000 PRINT #2, ":END" : PRINT #2, "CLS" : CLOSE (2)
2001 SHELL "HYPO_EM.BAT"
2002 SYSTEM
