100 '            pick_em.bas
110 '
111 '   the basic program that batches up the earthquake picking.
112 '   it does:
113 '      a) determines how many dmx files are left unpicked
115 '      b) prompts the user to see if they want to start picking every
117 '         quake or every x quakes.  The every x quakes can be important
119 '         in situations where the activity is so high that you will get
121 '         hopelessly behind if you try to pick every quake.
123 '      c) builds a giant batch file for the picking of the quakes.  
125 '         This batch file:
127 '         1) runs the quake through budspick
129 '         2) runs the output through hypo71
131 '         3) if it needs repicking it sends it back to budspick
131 '         4) if it is ok, it moves the dmx and pha files to the 
133 '            done directory
135 '
140 '  Skipped quakes can be moved to the overflow directory for later
142 '  processing or copied elsewhere for later use.
500 '------------------------------------------------------------------------
501 '   set up the directories
510 DMX$="C:\SEISMIC\BUDSPICK\DMX"
511 DONE$="C:\SEISMIC\BUDSPICK\DONE"
512 HYPO$="C:\SEISMIC\HYPO71"
514 SUDS$="C:\SEISMIC\BUDSPICK"
516 HYPOUT$="C:\SEISMIC\HYPO71\OUTPUT"
517 '  the name of the hypo station-velocity model (filename only, NO path)
519 MODEL$="STATIONS.INP"
520 '
521 '     get a listing of all *.dmx files needing to be picked
525 SHELL "DIR "+DMX$+"\*.DMX /A:-D /B | SORT >ERASEME.DAT"
530 '     now read through the file and simply count the number of events
531 OPEN "ERASEME.DAT" FOR INPUT AS 1
532 NUM%=0
535 IF EOF (1) THEN CLOSE (1) : GOTO 550
537    LINE INPUT #1, ALINE$ 
539    IF LEN(ALINE$)>10 THEN NUM%=NUM%+1
540    GOTO 535
550 PRINT USING "##### FILES TO BE PICKED";NUM%
551 IF NUM%=0 THEN SYSTEM
552 PRINT " DO YOU WISH TO PICK THEM ALL (A), ONLY A PORTION (P),"
553 INPUT "    OR A SPECIFIC EVENT (S) ";ALINE$
555 IF (ALINE$="A") OR (ALINE$="a") THEN ST%=0 : GOTO 600
557 IF (ALINE$="P") OR (ALINE$="p") THEN GOTO 580
560 IF (ALINE$="S") OR (ALINE$="s") THEN GOTO 561 ELSE BEEP : BEEP :BEEP: GOTO 552
561 SHELL "DIR "+DMX$+"\*.DMX /A:-D /O:N /W /P"
564 LOCATE 25,1
565 INPUT "ENTER EVENT TO BE PICKED (EX. 92050101.DMX) ";ALINE$
570 OPEN "ERASEME.DAT" FOR OUTPUT AS 1
571 PRINT #1,ALINE$ : CLOSE (1) : GOTO 600
575 '
580    INPUT "HOW MANY DO YOU WISH TO SKIP BETWEEN THOSE PICKED ? ";ALINE$
582    ST%=VAL(ALINE$)
600 '-----------------------------------------------------------------------
605 '        build the batch file
610 OPEN "ERASEME.DAT" FOR INPUT AS 1
620 OPEN "BATCH_PK.BAT" FOR OUTPUT AS 2
621 PRINT #2, "DEL ERASEME.DAT"
650 FOR I%=1 TO ST%
651     IF EOF(1) THEN CLOSE (1) : GOTO 2000
652     LINE INPUT #1, ALINE$
655     NEXT I%
660 IF EOF(1) THEN CLOSE (1) : GOTO 2000
675 LINE INPUT #1, DmxFile$
680 L%=LEN(DmxFile$)
681 IF L%<12 THEN PRINT "FILENAME NOT PROPER SYNTAX" : CLOSE (1) : SYSTEM
682 EVNT$=MID$(DmxFile$,L%-11,8)
684 PhaFile$=MID$(DmxFile$,1,(L%-3))+"PHA"
686 PhaIn$=HYPO$+"\"+EVNT$+".INP"
688 LBL$=RIGHT$(EVNT$,7)
700 '
705 '      our rentry spot if we are to re-pick it later
706 PRINT #2, ": P"+LBL$
710 PRINT #2, SUDS$+"\BUDSPICK.EXE "+DMX$+"\"+DmxFile$
711 PRINT #2, " "
732 '       create the hypo phase/station input file
735 PRINT #2, "COPY "+HYPO$+"\"+MODEL$+" + "+DMX$+"\"+PhaFile$+" "+PhaIn$
748 '        hypo needs to be run in the hypo directory
749 PRINT #2, "CD "+HYPO$
750 '        create the answers for the hypo prompts
751 PRINT #2, "HYPOIN.EXE EVENT="+EVNT$
752 '        run hypo
755 PRINT #2, HYPO$+"\HYPO71PC.EXE < HYPOIN.TXT"
756 PRINT #2, " "
757 '        get rid of the input file
759 'PRINT #2, "DEL "+EVNT$+".INP"
760 '        take the first line out of the PUN file
765 PRINT #2, HYPO$+"\NO_HDR.EXE "+HYPO$+"\"+EVNT$+".PUN"
771 '        display the results
772 PRINT #2, HYPO$+"\RESIDS.EXE  "+HYPO$+"\"+EVNT$+".PRT"
800 '--------------------------------------------------------
801 '       through the various steps depending on the errorlevel
802 '       returned by resids
803 '     we use the evnt$ minus the first digit for the various goto labels
805 LBL$=RIGHT$(EVNT$,7)
809 PRINT #2, ":-----------------------------------"
810 PRINT #2, "IF ERRORLEVEL 5 GOTO Q"+LBL$
811 PRINT #2, "IF ERRORLEVEL 4 GOTO K"+LBL$
812 PRINT #2, "IF ERRORLEVEL 3 GOTO D"+LBL$
813 PRINT #2, "IF ERRORLEVEL 2 GOTO S"+LBL$
814 PRINT #2, "IF ERRORLEVEL 1 GOTO P"+LBL$
815 PRINT #2, "GOTO N"+LBL$
820 '         good picks - save them
821 PRINT #2, ":S"+LBL$
823 PRINT #2, "     XCOPY "+HYPO$+"\"+EVNT$+".* "+HYPOUT$+"\*.*"
824 PRINT #2, "     IF ERRORLEVEL 1 GOTO W"+LBL$
825 PRINT #2, "     ERASE "+HYPO$+"\"+EVNT$+".*"
826 PRINT #2, "    :W"+LBL$
828 PRINT #2, "      XCOPY "+DMX$+"\"+EVNT$+".* "+DONE$+"\*.*"
830 PRINT #2, "      IF ERRORLEVEL 1 GOTO X"+LBL$
831 PRINT #2, "      ERASE "+DMX$+"\"+EVNT$+".*"
832 PRINT #2, "    :X"+LBL$
833 PRINT #2, "      GOTO N"+LBL$
840 PRINT #2, ":D"+LBL$
842 PRINT #2, "    ERASE "+DMX$+"\"+EVNT$+".*"
843 PRINT #2, "    ERASE "+HYPO$+"\"+EVNT$+".*"
844 PRINT #2, "    GOTO N"+LBL$
850 PRINT #2, ":K"+LBL$
852 PRINT #2, "    ERASE "+HYPO$+"\"+EVNT$+".*"
855 PRINT #2, "    GOTO N"+LBL$
865 PRINT #2, ":Q"+LBL$
866 PRINT #2, "    ERASE "+HYPO$+"\"+EVNT$+".*"
867 PRINT #2, "    GOTO END"
875 PRINT #2, ":N"+LBL$
876 PRINT #2, ":-------------------- next pick ----------------------"

900 GOTO 650
1999 '---------------------------------------------------
2000 PRINT #2, ":END" : PRINT #2, "CLS" : CLOSE (2)
2001 SHELL "BATCH_PK.BAT"
2002 SYSTEM
