10 '             cr_mastr.bas
11 '
12 '     this program takes the output from all the hypo71 output files
13 '     (*.pun) and appends them together in 1 master file.  this master
14 '     file can be used as input into the plotting programs or to generate
15 '     subfiles (all locations in a certain area, certain time span,
16 '     quality, etc.).
17 '
20 '     if the master file already exists, it renames it *.BAK and creates
21 '     the new one.
25 '
31 '     this program is started with the following command line:
40 '          CR_MASTR.EXE PUN=directory for *.PUN files OUT=masterfile name
41 '     for instance
42 '          CR_MASTR.EXE PUN=C:\SEISMIC\HYPO71\OUTPUT OUT=C:\DATA\MASTER.DAT
50 '
51 ' --------------------------------------------------------------------------
100 '  let the games begin
105 '
110 '                  first get the i/o stuff from the command line
120 IO$=COMMAND$
121 '                 any errors in command line and we go to 4000 to display
122 '                 the command line format
130 IF LEN(IO$)=0 THEN GOTO 4000
132 '                  if pun is not present we assume the local directory
135 PUN%=INSTR(IO$,"PUN=") : IF PUN%=0 THEN PUN$="" : GOTO 200
136 PUN%=PUN%+4
140 PUN$=""
145 '                 now extract the pun directory
150 IF PUN%>LEN(IO$) THEN GOTO 170
151    IF MID$(IO$,PUN%,1)=" " THEN GOTO 170
155    PUN$=PUN$+MID$(IO$,PUN%,1)
156    PUN%=PUN%+1
158    GOTO 150
170 PUN$=PUN$+"\"
200 '                get the OUT file in the same manner
235 OUTF%=INSTR(IO$,"OUT=") : IF OUTF%=0 THEN GOTO 4000
236 OUTF%=OUTF%+4
240 OUTF$=""
245 '                 now extract the out file
250 IF OUTF%>LEN(IO$) THEN GOTO 275
251    IF MID$(IO$,OUTF%,1)=" " THEN GOTO 275
255    OUTF$=OUTF$+MID$(IO$,OUTF%,1)
256    OUTF%=OUTF%+1
258    GOTO 250
275 IF LEN(OUTF$) < 1 THEN GOTO 4000
299 '------------------------------------------------------------------------
300 '                now the easy part
305 '         before we go to far, rename the present out file to *.BAK
310 '         if it doesnt exist, no harm is done
312 DOT%=INSTR(OUTF$,".")
315 IF DOT% = 0 THEN BAK$=OUTF$+".BAK"
316 IF DOT% <>0 THEN BAK$=MID$(OUTF$,1,DOT%)+"BAK"
320 SHELL "RENAME "+OUTF$+" "+BAK$ : SHELL "ERASE "+OUTF$
399 '--------------------------------------------------------------------------
400 '         get a list of all the files, sorted as to name in the pun
401 '         directory
410 SHELL "DIR "+PUN$+"*.PUN /a:-d /o:n /b >ERASEME.DAT"
420 '         now go through the file and build the master
450 OPEN "ERASEME.DAT" FOR INPUT AS #1
455 OPEN OUTF$ FOR OUTPUT AS #2
475 NUM%=0
476 ODAY$="      "
480 IF EOF(1) THEN GOTO 600
485    LINE INPUT #1, FILE1$
486 '            we'll print out each new day
487    IF LEFT$(FILE1$,6)<>ODAY$ THEN ODAY$=LEFT$(FILE1$,6) : PRINT ODAY$
490    FILE1$=PUN$+FILE1$
492    OPEN FILE1$ FOR INPUT AS #3
495    IF EOF (3) THEN GOTO 515
500       LINE INPUT #3, ALINE$
505 '           another spot to check for the header (we dont want it)
508       IF INSTR(ALINE$,"ORIGIN") <> 0 THEN GOTO 495
510       IF LEN(ALINE$)>0 THEN PRINT #2, ALINE$ : NUM%=NUM%+1
512       GOTO 495
515       CLOSE (3)
520    GOTO 480
549 '-----------------------------------------------------------------------
600 '                 all done - close the files
660 CLOSE (1) : CLOSE (2)
670 CLS
675 PRINT "FILE "+OUTF$+" CREATED"
676 PRINT USING "IT CONTAINS ###### LOCATIONS";NUM%
680 SYSTEM
3999 ' ----------------------------------------------------------------------
4000 '         error in the command line - print out instructions and exit
4010 BEEP : BEEP
4020 PRINT "ERROR IN COMMAND LINE"
4031 PRINT " this program is started with the following command line:"
4040 PRINT "   CR_MASTR.EXE PUN=directory for *.PUN files OUT=masterfile name"
4041 PRINT " for instance"
4042 PRINT "   CR_MASTR.EXE PUN=C:\SEISMIC\HYPO71\OUTPUT OUT=C:\DATA\MASTER.DAT"
4050 PRINT " "
4051 PRINT " If the PUN= argument is not present, CR_MASTR will assume the events"
4052 PRINT " are in the local directory. OUT= must always have an argument."
4060 SYSTEM
