10 '             select.bas
11 '
12 '     this program searches a file containing a list of hypocentral 
13 '     locations in HYPO71 *.PUN format and writes all events meeting  
14 '     the criteria specified in another file to an output file
17 '
20 '     if the output file already exists, it renames it *.BAK and creates
21 '     the new one.
30 '
31 '     this program is started with the following command line:
40 '          SELECT.EXE IN=MasterFile OUT=OutputFile FILTER=FilterSpecFile
41 '     for instance
42 '          SELECT.EXE IN=MASTER.DAT OUT=MSH.DAT FILTER=MSH.FLT
50 '
51 ' --------------------------------------------------------------------------
100 '  let the games begin
105 '
110 '                  first get the i/o stuff from the command line
120 IO$=COMMAND$
121 '                 any errors in command line and we go to 4000 to display
122 '                 the command line format
130 IF LEN(IO$)=0 THEN GOTO 4000
132 '             get the input file
134 INN%=INSTR(IO$,"in=") : IF INN%<>0 THEN GOTO 136
135 INN%=INSTR(IO$,"IN=") : IF INN%=0 THEN GOTO 4000
136 INN%=INN%+3
140 INN$=""
145 '                 now extract the master file
150 IF INN%>LEN(IO$) THEN GOTO 190
151    IF MID$(IO$,INN%,1)=" " THEN GOTO 190
155    INN$=INN$+MID$(IO$,INN%,1)
156    INN%=INN%+1
158    GOTO 150
190 IF LEN(INN$) <1 THEN GOTO 4000
200 '                get the OUT file in the same manner
234 OUTF%=INSTR(IO$,"out=") : IF OUTF%<>0 THEN GOTO 236
235 OUTF%=INSTR(IO$,"OUT=") : IF OUTF%=0 THEN GOTO 4000
236 OUTF%=OUTF%+4
240 OUTF$=""
245 '                 now extract the out file
250 IF OUTF%>LEN(IO$) THEN GOTO 275
251    IF MID$(IO$,OUTF%,1)=" " THEN GOTO 275
255    OUTF$=OUTF$+MID$(IO$,OUTF%,1)
256    OUTF%=OUTF%+1
258    GOTO 250
275 IF LEN(OUTF$) < 1 THEN GOTO 4000
300 '                get the FILTER file in the same manner
334 FIL%=INSTR(IO$,"filter=") : IF FIL%<>0 THEN GOTO 336
335 FIL%=INSTR(IO$,"FILTER=") : IF FIL%=0 THEN GOTO 4000
336 FIL%=FIL%+7
340 FIL$=""
345 '                 now extract the filter file
350 IF FIL%>LEN(IO$) THEN GOTO 375
351    IF MID$(IO$,FIL%,1)=" " THEN GOTO 375
355    FIL$=FIL$+MID$(IO$,FIL%,1)
356    FIL%=FIL%+1
358    GOTO 350
375 IF LEN(FIL$) < 1 THEN GOTO 4000
399 '------------------------------------------------------------------------
500 '                now the easy part
505 '         before we go too far, rename the present out file to *.BAK
510 '         if it doesnt exist, no harm is done
512 DOT%=INSTR(OUTF$,".")
515 IF DOT% = 0 THEN BAK$=OUTF$+".BAK"
516 IF DOT% <>0 THEN BAK$=MID$(OUTF$,1,DOT%)+"BAK"
520 SHELL "ERASE "+BAK$ : SHELL "RENAME "+OUTF$+" "+BAK$
599 '--------------------------------------------------------------------------
600 '         get the filter criteria
610 OPEN FIL$ FOR INPUT AS #1
615 '         set all our criterias to don't do by setting them to 0
620 TLO% = 0  'no minimum beginning time
621 THI% = 0  'no ending time
622 LATLO% = 0 'no minimum latitude
623 LATHI% = 0 'no maximum latitude
624 LONLO% = 0 'no minimum longitude
625 LONHI% = 0 'no maximum longitude
626 NORAD% = 0 'no maximum radius from a point
627 DEPLO% = 0 'no maximum depth
628 DEPHI% = 0 'no minimum depth
629 MAGLO% = 0 'no minimum magnitude
630 MAGHI% = 0 'no maximum magnitude
631 NOSTA% = 0 'no minimum stations recording
632 RMS%   = 0 'no maximum RMS 
633 Q%     = 0 'no minumum quality
634 ERH%   = 0 'no maximum standard error of epicenter
635 ERZ%   = 0 'no maximum standard error of focal depth 
636 DM%    = 0 'no maximum epicentral distance to nearest station
698 '         now get the data from the filter file
699 '         we'll read each line. if it starts with a # we'll send it 
700 '         to the sub that decodes the criteria
710 IF EOF(1) THEN GOTO 745
715    LINE INPUT #1, ALINE$
720    IF LEN(ALINE$) < 1 THEN GOTO 710
725    IF MID$(ALINE$,1,1) <> "#" THEN GOTO 710
726 '         get rid of trailing blanks
730    DUM%=LEN(ALINE$)
732    IF MID$(ALINE$,DUM%,1) =" " THEN DUM%=DUM%-1 : ALINE$=LEFT$(ALINE$,DUM%) : GOTO 732
735 '         if we are at an equal sign we also skip the line
737    IF MID$(ALINE$,DUM%,1) = "=" THEN GOTO 710
739 '         goto the decoder
740    GOSUB 3500 : GOTO 710
745 CLOSE (1)
750 '--------------------------------------------------------------------------
800 '        with that done open the two data files and start filtering 
801 '        out unwanted data
803 CLS : LOCATE 1,1 
804 PRINT "PROCESSING DAY                0 SELECTED FROM      0 EVENTS TOTAL"
810 OPEN INN$ FOR INPUT AS #1
811 OPEN OUTF$ FOR OUTPUT AS #2
815 '         ody$ will let us print out each new day we hit in the file
816 SLCT!=0 : TOTAL!=0
820 IF EOF(1) THEN GOTO  900
825    LINE INPUT #1,ALINE$ : TOTAL!=TOTAL!+1
827 '        give the viewer something to watch
828    LOCATE 1,16 : PRINT MID$(ALINE$,1,6) : LOCATE 1,47 : PRINT USING "######"; TOTAL!
830 '        we set good to +1.  if any criteria causes us to not want the 
831 '        event, it will get set to 0 and we wont save it in the new file.
835    GOOD%=1
840 '        go check it out
841    GOSUB 2000
850    IF GOOD%=1 THEN PRINT #2, ALINE$ : SLCT!=SLCT!+1 : LOCATE 1,26 : PRINT USING "######";SLCT!
855    GOTO 820
900 '       all done
901 CLOSE (1) : CLOSE (2) : SYSTEM
910 '**************************************************************************

2000 '-----------------------------------------------------------------------
2001 '       routine that weeds out unwanted events
2010 IF TLO% = 0 THEN GOTO 2020
2012    DUM1#=VAL(MID$(ALINE$,1,6))+VAL(MID$(ALINE$,8,2))/24#+VAL(MID$(ALINE$,10,2))/1440#
2014    IF DUM1#<TLO# THEN GOOD%=0 : RETURN
2020 IF THI% = 0 THEN GOTO 2030
2021    '         see if we already calculated the event time
2022    IF TLO%<>0 THEN GOTO 2024
2023    DUM1#=VAL(MID$(ALINE$,1,6))+VAL(MID$(ALINE$,8,2))/24#+VAL(MID$(ALINE$,10,2))/1440#
2024    IF DUM1#>THI# THEN GOOD%=0 : RETURN
2030 IF LATLO%=0 THEN GOTO 2040
2032    DUM1#=VAL(MID$(ALINE$,19,2))+VAL(MID$(ALINE$,22,5))/60#
2034    IF DUM1# < LATLO# THEN GOOD%=0 : RETURN
2040 IF LATHI%=0 THEN GOTO 2050
2041    IF LATLO%<>0 THEN GOTO 2044
2042    DUM1#=VAL(MID$(ALINE$,19,2))+VAL(MID$(ALINE$,22,5))/60#
2044    IF DUM1# >LATHI# THEN GOOD%=0 : RETURN
2050 IF LONLO% = 0 THEN GOTO 2060
2052    DUM1#=VAL(MID$(ALINE$,28,3))+ VAL(MID$(ALINE$,32,5))/60#
2054    IF DUM1# < LONLO# THEN GOOD%=0 : RETURN
2060 IF LONHI% = 0 THEN GOTO 2070
2061    IF LONLO%<>0 THEN GOTO 2064
2062    DUM1#=VAL(MID$(ALINE$,28,3))+ VAL(MID$(ALINE$,32,5))/60#
2064    IF DUM1# > LONHI# THEN GOOD%=0 : RETURN
2070 IF RAD% < 3 THEN GOTO 2090
2071 '        must be within a radius of a spot.  we ignore sphereical
2072 '        consdirations since the radius should usually be small (<100km)
2073    LON#=VAL(MID$(ALINE$,28,3))+VAL(MID$(ALINE$,32,5))/60#
2074    LAT#=VAL(MID$(ALINE$,19,2))+VAL(MID$(ALINE$,22,5))/60#
2075 '        divide the polar circum (r=6356.912 km) by 360 degrees for 
2076 '        latitude km/degree and equator circum (r=6378.388 km) by 360 
2077 '        degrees for longitude km/degreee
2078    DUM1#=ABS(LON#-RADLON#)*111.324
2079    DUM2#=ABS(LAT#-RADLAT#)*110.949
2080 '        correct longitude km/degrees for how high up we are latitude
2081    DUM1#=DUM1#*LONCOR#
2082    DUM1#=SQR(DUM1#*DUM1#+DUM2#*DUM2#)
2084    IF DUM1#>RAD# THEN GOOD%=0 : RETURN
2090 IF DEPLO% = 0 THEN GOTO 2100
2094    DUM1!=VAL(MID$(ALINE$,38,6))
2092    IF DUM1! >DEPLO! THEN GOOD%=0 : RETURN
2100 IF DEPHI% = 0 THEN GOTO 2110
2102    DUM1!=VAL(MID$(ALINE$,38,6))
2104    IF DUM1!<DEPHI! THEN GOOD%= 0 :RETURN
2110 IF MAGLO% = 0 THEN GOTO 2120
2112    DUM1!=VAL(MID$(ALINE$,46,5))
2114    IF DUM1! <MAGLO! THEN GOOD%=0 : RETURN
2120 IF MAGHI% = 0 THEN GOTO 2130
2122    DUM1!=VAL(MID$(ALINE$,46,5))
2124    IF DUM1!>MAGHI!THEN GOOD%=0 : RETURN
2130 IF NOSTA% = 0 THEN GOTO 2140
2132    DUM1!=VAL(MID$(ALINE$,52,2))
2134    IF DUM1! <NOSTA! THEN GOOD%=0 : RETURN
2140 IF RMS% = 0 THEN GOTO 2150
2142    DUM1!=VAL(MID$(ALINE$,64,4))
2144    IF DUM1!>RMS! THEN GOOD%=0 : RETURN
2150 IF Q% = 0 THEN GOTO 2160
2152    DUM1$=MID$(ALINE$,79,1)
2154    IF DUM1$>Q$ THEN GOOD%=0 : RETURN
2160 IF ERH% = 0 THEN GOTO 2170
2162    DUM1!=VAL(MID$(ALINE$,69,4))
2164    IF DUM1!>ERH! THEN GOOD%=0 : RETURN
2170 IF ERZ% = 0 THEN GOTO 2180
2172    DUM1!=VAL(MID$(ALINE$,74,4))
2174    IF DUM1!>ERZ! THEN GOOD%=0 : RETURN
2180 IF DM% = 0 THEN GOTO 2190
2182    DUM1!=VAL(MID$(ALINE$,59,4))
2184    IF DUM1!>DM! THEN GOOD%=0 : RETURN
2190 RETURN
3500 '*********************************************************************
3501 '                 routine to decode a critera line
3502 EQ%=INSTR(ALINE$,"=")-1 : EN%=LEN(ALINE$)
3510 IF MID$(ALINE$,2,EQ%)<>"BEGINNING_TIME=" THEN GOTO 3520
3512    TLO#=VAL(MID$(ALINE$,17,6))
3514    IF EN%<23 THEN TLO%=1 : RETURN
3515    TLO#=TLO#+VAL(MID$(ALINE$,24,EN%))
3516    TLO%=1 : RETURN
3520 IF MID$(ALINE$,2,EQ%)<>"END_TIME=" THEN GOTO 3530
3522    THI#=VAL(MID$(ALINE$,11,6))
3524    IF EN%<17 THEN THI%=1 : RETURN
3525    THI#=THI#+VAL(MID$(ALINE$,18,EN%)) 
3526    THI%=1 : RETURN
3530 IF MID$(ALINE$,2,EQ%)<>"MIN_LAT=" THEN GOTO 3540
3532    LATLO#=VAL(MID$(ALINE$,10,3))+VAL(MID$(ALINE$,14,EN%))/60#
3534    LATLO%=1 : RETURN
3540 IF MID$(ALINE$,2,EQ%)<>"MAX_LAT=" THEN GOTO 3550
3542    LATHI#=VAL(MID$(ALINE$,10,3))+VAL(MID$(ALINE$,14,EN%))/60#
3544    LATHI%=1 : RETURN
3550 IF MID$(ALINE$,2,EQ%)<>"MIN_LONG=" THEN GOTO 3560
3552    LONLO=VAL(MID$(ALINE$,11,4))+VAL(MID$(ALINE$,16,EN%))/60#
3554    LONLO%=1 : RETURN
3560 IF MID$(ALINE$,2,EQ%)<>"MAX_LONG=" THEN GOTO 3570
3562    LONHI#=VAL(MID$(ALINE$,11,4))+VAL(MID$(ALINE$,16,EN%))/60#
3564    LONHI%=1 : RETURN
3570 IF MID$(ALINE$,2,EQ%)<>"RADIUS=" THEN GOTO 3580
3572    RAD#=VAL(MID$(ALINE$,9,EN%))
3574    RAD%=RAD%+1 : RETURN
3580 IF MID$(ALINE$,2,EQ%)<>"RADIUS_LAT=" THEN GOTO 3590
3582    RADLAT#=VAL(MID$(ALINE$,13,3))+VAL(MID$(ALINE$,17,EN%))/60#
3583 '         calculate the correction for longitude km/degree here
3584 '         so we don't do it all the time. since the radius should be
3585 '         relatively small <100 km instead of >1000 km we'll just
3586 '         use the correction from the center of the circle 
3587    LONCOR#=COS(RADLAT#*2#*3.14159#/360#)
3588    RAD%=RAD%+1 : RETURN
3590 IF MID$(ALINE$,2,EQ%)<>"RADIUS_LONG=" THEN GOTO 3600
3592    RADLON#=VAL(MID$(ALINE$,14,4))+VAL(MID$(ALINE$,19,EN%))/60#
3594    RAD%=RAD%+1 : RETURN
3600 IF MID$(ALINE$,2,EQ%)<>"MAX_DEPTH=" THEN GOTO 3610
3602    DEPLO!=VAL(MID$(ALINE$,12,EN%))
3604    DEPLO%=1 : RETURN
3610 IF MID$(ALINE$,2,EQ%)<>"MIN_DEPTH=" THEN GOTO 3620
3612    DEPHI!=VAL(MID$(ALINE$,12,EN%))
3614    DEPHI%=1 : RETURN
3620 IF MID$(ALINE$,2,EQ%)<>"MIN_MAGNITUDE=" THEN GOTO 3630
3622    MAGLO!=VAL(MID$(ALINE$,16,EN%))
3624    MAGLO%=1 : RETURN
3630 IF MID$(ALINE$,2,EQ%)<>"MAX_MAGNITUDE=" THEN GOTO 3640
3632    MAGHI!=VAL(MID$(ALINE$,16,EN%))
3634    MAGHI%=1 : RETURN
3640 IF MID$(ALINE$,2,EQ%)<>"MIN_STATIONS=" THEN GOTO 3650
3642    NOSTA!=VAL(MID$(ALINE$,15,EN%))
3644    NOSTA%=1 : RETURN
3650 IF MID$(ALINE$,2,EQ%)<>"MAX_RMS=" THEN GOTO 3660
3652    RMS!=VAL(MID$(ALINE$,10,EN%))
3654    RMS%=1 : RETURN
3660 IF MID$(ALINE$,2,EQ%) <> "MIN_QUALITY=" THEN GOTO 3670
3662    Q$=MID$(ALINE$,14,1)
3664    Q%=1 : RETURN
3670 IF MID$(ALINE$,2,EQ%)<>"MAX_FOCAL_ERR=" THEN GOTO 3660
3672    ERZ!=VAL(MID$(ALINE$,16,EN%))
3674    ERZ%=1 : RETURN
3680 IF MID$(ALINE$,2,EQ%)<>"MAX_EPICENTER_ERR=" THEN GOTO 3660
3682    ERH!=VAL(MID$(ALINE$,20,EN%))
3684    ERH%=1 : RETURN
3690 IF MID$(ALINE$,2,EQ%)<>"MAX_2_NEAREST_STA=" THEN GOTO 3660
3692    DM!=VAL(MID$(ALINE$,20,EN%))
3694    DM%=1 : RETURN
3700 '              something wrong if we get here
3702 BEEP : PRINT "ILLEGAL LINE IN CRITERIA FILE" : PRINT ALINE$ : SYSTEM
3800 '---------------------------------------------------------------------
4000 '*********************************************************************
4001 PRINT "COMMAND LINE ERROR"
4010 PRINT "COMMAND LINE SHOULD BE AS FOLLOWS:"
4015 PRINT " "
4016 PRINT "SELECT.EXE IN=MasterFile OUT=OutPutFile FILTER=FilterFile"
4020 PRINT " "
4022 SYSTEM
